-- by mor2000

--------------------
-- Base (root of every building, has no parent, main storage in simple buildings)

UPK_Base={}
local UPK_Base_mt = Class(UPK_Base, UniversalProcessKit)
InitObjectClass(UPK_Base, "UPK_Base")
UniversalProcessKit.addModule("base",UPK_Base)

function UPK_Base.onCreate(id)
	local object = UPK_Base:new(g_server ~= nil, g_client ~= nil)
	if object:load(id) then
		g_currentMission:addOnCreateLoadedObject(object)
	else
		object:delete()
	end
end

function UPK_Base:new(isServer, isClient, customMt)
	if customMt == nil then
		customMt = UPK_Base_mt
	end
	local self = UniversalProcessKit:new(isServer, isClient, customMt)
	registerObjectClassName(self, "UPK_Base")
	return self
end

function UPK_Base:load(id)
	UPK_Base:superClass().load(self, id, nil)
	self.fillLevels={}
	for k,_ in pairs(Fillable.fillTypeIntToName) do
		self:setFillLevel(0,k,true)
	end
	for k,_ in pairs(UniversalProcessKit.fillTypeIntToName) do
		self:setFillLevel(0,k,true)
	end
	return true
end

function UPK_Base:delete()
	UPK_Base:superClass().delete(self)
end

function UPK_Base:executeAction(sender, action, value)
	UPK_Base:superclass().executeAction(sender, action, value)
	-- extend functionality down here (in your own modules)
end

-- only for base module!
g_onCreateUtil.addOnCreateFunction("UniversalProcessKitOnCreate", UPK_Base.onCreate);
