-- by mor2000

-- DumpTrigger (for dumping stuff out of shovels and combines)

UPK_DumpTrigger={}
local UPK_DumpTrigger_mt = Class(UPK_DumpTrigger, UniversalProcessKit)
InitObjectClass(UPK_DumpTrigger, "UPK_DumpTrigger")
UniversalProcessKit.addModule("dumptrigger",UPK_DumpTrigger)

function UPK_DumpTrigger:new(isServer, isClient, customMt)
	if customMt == nil then
		customMt = UPK_DumpTrigger_mt
	end
	local self = UniversalProcessKit:new(isServer, isClient, customMt)
	registerObjectClassName(self, "UPK_DumpTrigger")
	return self
end

function UPK_DumpTrigger:load(id, parent)
	UPK_DumpTrigger:superClass().load(self, id, parent)

	self:register(true)
	
	-- for combine raycast
	g_currentMission.nodeToVehicle[id] = self
	-- for shovel raycast
	g_currentMission:addNodeObject(id,self)

    local function tobool(val)
  		return not (val == nil or val == false or val == 0 or val == "0" or val == "false" )
    end
	
	-- dummies for combines
	
	self.fillRootNode=id
	self.exactFillRootNode=id
	self.fillAutoAimTargetNode=id
	self.fillType=Fillable.FILLTYPE_UNKNOWN
	self.fillLevel=0
	self.resetFillLevelIfNeeded=self.setFillType
	self.addFillLevel=self.setFillLevel
	
	return true
end

function UPK_DumpTrigger:delete()
	UPK_DumpTrigger:superClass().delete(self)
end

function UPK_DumpTrigger:getFillType()
	return self.fillType
end

function UPK_DumpTrigger:setFillType(fillType)
	self.fillType = fillType
end

function UPK_DumpTrigger:setFillLevel(fillLevel,fillType)
	self:setFillType(Fillable.FILLTYPE_UNKNOWN)
	-- problem with self.capacity at parents
	return self.parent:addFillLevel(fillLevel,fillType)
end

function UPK_DumpTrigger:allowFillType(fillType)
	return self.isEnabled and fillType ~= Fillable.FILLTYPE_UNKNOWN and self.acceptedFillTypes[fillType]
end

function UPK_DumpTrigger:getAllowFillFromAir()
	return self.isEnabled
end

function UPK_DumpTrigger:getIsAttachedTo(combine)
	return false
end

function UPK_DumpTrigger:addShovelFillLevel(shovel, delta, fillType)
	local tmp=self:addFillLevel(delta,fillType)
	return tmp
end

function UPK_DumpTrigger:getAllowShovelFillType(fillType)
	return self.isEnabled and self:allowFillType(fillType) and self.fillLevels[fillType]<self.capacity
end
